{******************************************************************************}
{                       CnPack For Delphi/C++Builder                           }
{                     йԼĿԴ                         }
{                   (C)Copyright 2001-2019 CnPack                        }
{                   ------------------------------------                       }
{                                                                              }
{            ǿԴ CnPack ķЭ        }
{        ĺ·һ                                                }
{                                                                              }
{            һĿϣãûκεû        }
{        ʺضĿĶĵϸ CnPack Э顣        }
{                                                                              }
{            ӦѾͿһյһ CnPack Эĸ        }
{        ûУɷǵվ                                            }
{                                                                              }
{            վַhttp://www.cnpack.org                                   }
{            ʼmaster@cnpack.org                                       }
{                                                                              }
{******************************************************************************}

{******************************************************************************}
{ Unit Note:                                                                   }
{    This file is partly derived from GExperts 1.2                             }
{                                                                              }
{ Original author:                                                             }
{    GExperts, Inc  http://www.gexperts.org/                                   }
{    Erik Berry <eberry@gexperts.org> or <eb@techie.com>                       }
{******************************************************************************}

unit CnWizIdeUtils;
{* |<PRE>
================================================================================
* ƣCnPack IDE רҰ
* Ԫƣڽűʹõ CnIdeWizUtils Ԫ
* ԪߣCnPack 
*     עԪͺͺ PasScript űʹ
* ƽ̨PWin2000Pro + Delphi 5.01
* ݲԣPWin9X/2000/XP + Delphi 5/6/7 + C++Builder 5/6
*   õԪеַϱػʽ
* ޸ļ¼2006.12.31 V1.0
*               Ԫ
================================================================================
|</PRE>}

interface

uses
  Windows, Messages, Classes, Controls, SysUtils, Graphics, Forms, ComCtrls,
  ExtCtrls, Menus, Buttons, Tabs,
{$IFNDEF VER130}
  DesignIntf,
{$ENDIF}
  ToolsAPI;

//==============================================================================
// IDE ༭ܺ
//==============================================================================

function IdeGetEditorSelectedLines(Lines: TStringList): Boolean;
{* ȡõǰ༭ѡеĴ룬ʹģʽѡΪգ򷵻صǰд롣}

function IdeGetEditorSelectedText(Lines: TStringList): Boolean;
{* ȡõǰ༭ѡĴ롣}

function IdeGetEditorSourceLines(Lines: TStringList): Boolean;
{* ȡõǰ༭ȫԴ롣}

function IdeSetEditorSelectedLines(Lines: TStringList): Boolean;
{* 滻ǰ༭ѡеĴ룬ʹģʽѡΪգ滻ǰд롣}

function IdeSetEditorSelectedText(Lines: TStringList): Boolean;
{* 滻ǰ༭ѡĴ롣}

function IdeSetEditorSourceLines(Lines: TStringList): Boolean;
{* 滻ǰ༭ȫԴ롣}

function IdeInsertTextIntoEditor(const Text: string): Boolean;
{* ıǰ༭ֶ֧ı}

function IdeEditorGetEditPos(var Col, Line: Integer): Boolean;
{* صǰλã EditView Ϊʹõǰֵ }

function IdeEditorGotoEditPos(Col, Line: Integer; Middle: Boolean): Boolean;
{* ƶ굽ָλãMiddle ʾǷƶͼġ}

function IdeGetBlockIndent: Integer;
{* õǰ༭ }

function IdeGetSourceByFileName(const FileName: string): string;
{* ļȡݡļ IDE д򿪣ر༭еݣ򷵻ļݡ}

function IdeSetSourceByFileName(const FileName: string; Source: TStrings;
  OpenInIde: Boolean): Boolean;
{* ļдݡļ IDE д򿪣дݵ༭У
   OpenInIde Ϊļд뵽༭OpenInIde Ϊֱдļ}

//==============================================================================
// IDE ༭ܺ
//==============================================================================

function IdeGetFormDesigner(FormEditor: IOTAFormEditor = nil): IDesigner;
{* ȡô༭FormEditor Ϊ nil ʾȡǰ }

function IdeGetDesignedForm(Designer: IDesigner = nil): TCustomForm;
{* ȡõǰƵĴ }

function IdeGetFormSelection(Selections: TList; Designer: IDesigner = nil;
  ExcludeForm: Boolean = True): Boolean;
{* ȡõǰƴѡ }
 
//==============================================================================
// ޸ GExperts Src 1.12  IDE غ
//==============================================================================

function GetIdeMainForm: TCustomForm;
{*  IDE  (TAppBuilder) }

function GetIdeEdition: string;
{*  IDE 汾}

function GetComponentPaletteTabControl: TTabControl;
{* 󣬿Ϊգֻ֧ 2010 °汾}

function GetNewComponentPaletteTabControl: TWinControl;
{*  2010 ϵϰ벿 Tab 󣬿Ϊ}

function GetNewComponentPaletteComponentPanel: TWinControl;
{*  2010 ϵ°벿б󣬿Ϊ}

function GetObjectInspectorForm: TCustomForm;
{* ض壬Ϊ}

function GetComponentPalettePopupMenu: TPopupMenu;
{* Ҽ˵Ϊ}

function GetComponentPaletteControlBar: TControlBar;
{* ڵControlBarΪ}

function GetMainMenuItemHeight: Integer;
{* ˵߶ }

function IsIdeEditorForm(AForm: TCustomForm): Boolean;
{* жָǷ༭}

function IsIdeDesignForm(AForm: TCustomForm): Boolean;
{* жָǷڴ}

procedure BringIdeEditorFormToFront;
{* Դ༭ΪԾ}

function IDEIsCurrentWindow: Boolean;
{* ж IDE ǷǵǰĻ }

//==============================================================================
//  IDE غ
//==============================================================================

function GetInstallDir: string;
{* ȡװĿ¼}

{$IFDEF BDS}
function GetBDSUserDataDir: string;
{* ȡ BDS (Delphi8/9) ûĿ¼ }
{$ENDIF}

procedure GetProjectLibPath(Paths: TStrings);
{* ȡǰ Path }

function GetFileNameFromModuleName(AName: string; AProject: IOTAProject = nil): string;
{* ģļ}

function CnOtaGetVersionInfoKeys(Project: IOTAProject = nil): TStrings;
{* ȡǰĿеİ汾Ϣֵ}

procedure GetLibraryPath(Paths: TStrings; IncludeProjectPath: Boolean = True);
{* ȡе LibraryPath }

function GetComponentUnitName(const ComponentName: string): string;
{* ȡڵĵԪ}

procedure GetInstalledComponents(Packages, Components: TStrings);
{* ȡѰװİΪ nilԣ}

function GetEditControlFromEditorForm(AForm: TCustomForm): TControl;
{* ر༭ڵı༭ؼ }

function GetCurrentEditControl: TControl;
{* صǰĴ༭ؼ }

function GetStatusBarFromEditor(EditControl: TControl): TStatusBar;
{* ӱ༭ؼı༭ڵ״̬}

function GetCurrentSyncButton: TControl;
{* ȡǰǰ˱༭﷨༭ťע﷨༭ťڲڿɼ}

function GetCurrentSyncButtonVisible: Boolean;
{* ȡǰǰ˱༭﷨༭ťǷɼްť򲻿ɼ False}

function GetCodeTemplateListBox: TControl;
{* ر༭еĴģԶ}

function GetCodeTemplateListBoxVisible: Boolean;
{* ر༭еĴģԶǷɼ޻򲻿ɼ False}

function IsCurrentEditorInSyncMode: Boolean;
{* ǰ༭Ƿ﷨༭ģʽ£ֻ֧ڿģʽ· False}

function IsKeyMacroRunning: Boolean;
{* ǰǷڼ̺¼ƻطţֻ֧ڷ False}

function GetCurrentCompilingProject: IOTAProject;
{* صǰڱḶ́עⲻһǵǰ}

//==============================================================================
// װ
//==============================================================================

type

{ TCnPaletteWrapper }

  TCnPaletteWrapper = class(TObject)
  private
    function GetActiveTab: string;
    function GetEnabled: Boolean;
    function GetIsMultiLine: Boolean;
    function GetPalToolCount: Integer;
    function GetSelectedIndex: Integer;
    function GetSelectedToolName: string;
    function GetSelector: TSpeedButton;
    function GetTabCount: Integer;
    function GetTabIndex: Integer;
    function GetTabs(Index: Integer): string;
    function GetVisible: Boolean;
    procedure SetEnabled(const Value: Boolean);
    procedure SetSelectedIndex(const Value: Integer);
    procedure SetTabIndex(const Value: Integer);
    procedure SetVisible(const Value: Boolean);

  public
    constructor Create;

    procedure BeginUpdate;
    {* ʼ£ֹˢҳ }
    procedure EndUpdate;
    {* ֹͣ£ָˢҳ }
    function SelectComponent(const AComponent: string; const ATab: string): Boolean;
    {* ѡпؼеĳؼ }
    function FindTab(const ATab: string): Integer;
    {* ĳҳ }
    property SelectedIndex: Integer read GetSelectedIndex write SetSelectedIndex;
    {* µĿؼڱҳţ0 ͷ }
    property SelectedToolName: string read GetSelectedToolName;
    {* µĿؼδΪ }
    property Selector: TSpeedButton read GetSelector;
    {* л SpeedButton }
    property PalToolCount: Integer read GetPalToolCount;
    {* ǰҳؼ }
    property ActiveTab: string read GetActiveTab;
    {* ǰҳ }
    property TabIndex: Integer read GetTabIndex write SetTabIndex;
    {* ǰҳ }
    property Tabs[Index: Integer]: string read GetTabs;
    {* õҳ }
    property TabCount: Integer read GetTabCount;
    {* ؼҳ }
    property IsMultiLine: Boolean read GetIsMultiLine;
    {* ؼǷ }
    property Visible: Boolean read GetVisible write SetVisible;
    {* ؼǷɼ }
    property Enabled: Boolean read GetEnabled write SetEnabled;
    {* ؼǷʹ }
  end;

{ TCnMessageViewWrapper }

{$IFDEF BDS}
  TXTreeView = TCustomControl;
{$ELSE}
  TXTreeView = TTreeView;
{$ENDIF BDS}

  TCnMessageViewWrapper = class(TObject)
  {* װϢʾڵĸԵ }
  private
    FMessageViewForm: TCustomForm;
    FEditMenuItem: TMenuItem;
    FTabSet: TTabSet;
    FTreeView: TXTreeView;
{$IFNDEF BDS}
    function GetMessageCount: Integer;
    function GetSelectedIndex: Integer;
    procedure SetSelectedIndex(const Value: Integer);
    function GetCurrentMessage: string;
{$ENDIF}
    function GetTabCaption: string;
    function GetTabCount: Integer;
    function GetTabIndex: Integer;
    procedure SetTabIndex(const Value: Integer);
    function GetTabSetVisible: Boolean;
  public
    constructor Create;

    procedure UpdateAllItems;

    procedure EditMessageSource;
    {* ˫Ϣ}

    property MessageViewForm: TCustomForm read FMessageViewForm;
    {* Ϣ}
    property TreeView: TXTreeView read FTreeView;
    {* ϢʵBDS · TreeViewֻܷ CustomControl }
{$IFNDEF BDS}
    property SelectedIndex: Integer read GetSelectedIndex write SetSelectedIndex;
    {* Ϣѡе}
    property MessageCount: Integer read GetMessageCount;
    {* еϢ}
    property CurrentMessage: string read GetCurrentMessage;
    {* ǰѡеϢƺǷؿ}
{$ENDIF}
    property TabSet: TTabSet read FTabSet;
    {* طҳʵ}
    property TabSetVisible: Boolean read GetTabSetVisible;
    {* طҳǷɼD5 Ĭϲɼ}
    property TabIndex: Integer read GetTabIndex write SetTabIndex;
    {* /õǰҳ}
    property TabCount: Integer read GetTabCount;
    {* ҳ}
    property TabCaption: string read GetTabCaption;
    {* صǰҳַ}
    property EditMenuItem: TMenuItem read FEditMenuItem;
    {* '༭'˵}
  end;

function CnPaletteWrapper: TCnPaletteWrapper;

function CnMessageViewWrapper: TCnMessageViewWrapper;

implementation

{$WARNINGS OFF}

function IdeGetEditorSelectedLines(Lines: TStringList): Boolean;
begin
end;

function IdeGetEditorSelectedText(Lines: TStringList): Boolean;
begin
end;

function IdeGetEditorSourceLines(Lines: TStringList): Boolean;
begin
end;

function IdeSetEditorSelectedLines(Lines: TStringList): Boolean;
begin
end;

function IdeSetEditorSelectedText(Lines: TStringList): Boolean;
begin
end;

function IdeSetEditorSourceLines(Lines: TStringList): Boolean;
begin
end;

function IdeInsertTextIntoEditor(const Text: string): Boolean;
begin
end;

function IdeEditorGetEditPos(var Col, Line: Integer): Boolean;
begin
end;

function IdeEditorGotoEditPos(Col, Line: Integer; Middle: Boolean): Boolean;
begin
end;

function IdeGetBlockIndent: Integer;
begin
end;

function IdeGetSourceByFileName(const FileName: string): string;
begin
end;

function IdeSetSourceByFileName(const FileName: string; Source: TStrings;
  OpenInIde: Boolean): Boolean;
begin
end;

function IdeGetFormDesigner(FormEditor: IOTAFormEditor = nil): IDesigner;
begin
end;

function IdeGetDesignedForm(Designer: IDesigner = nil): TCustomForm;
begin
end;

function IdeGetFormSelection(Selections: TList; Designer: IDesigner = nil;
  ExcludeForm: Boolean = True): Boolean;
begin
end;

function GetIdeMainForm: TCustomForm;
begin
end;

function GetIdeEdition: string;
begin
end;

function GetComponentPaletteTabControl: TTabControl;
begin
end;

function GetNewComponentPaletteTabControl: TWinControl;
begin
end;

function GetNewComponentPaletteComponentPanel: TWinControl;
begin
end;

function GetObjectInspectorForm: TCustomForm;
begin
end;

function GetComponentPalettePopupMenu: TPopupMenu;
begin
end;

function GetComponentPaletteControlBar: TControlBar;
begin
end;

function GetMainMenuItemHeight: Integer;
begin
end;

function IsIdeEditorForm(AForm: TCustomForm): Boolean;
begin
end;

function IsIdeDesignForm(AForm: TCustomForm): Boolean;
begin
end;

procedure BringIdeEditorFormToFront;
begin
end;

function IDEIsCurrentWindow: Boolean;
begin
end;

function GetInstallDir: string;
begin
end;

function GetBDSUserDataDir: string;
begin
end;

procedure GetProjectLibPath(Paths: TStrings);
begin
end;

function GetFileNameFromModuleName(AName: string; AProject: IOTAProject = nil): string;
begin
end;

function CnOtaGetVersionInfoKeys(Project: IOTAProject = nil): TStrings;
begin
end;

procedure GetLibraryPath(Paths: TStrings; IncludeProjectPath: Boolean = True);
begin
end;

function GetComponentUnitName(const ComponentName: string): string;
begin
end;

procedure GetInstalledComponents(Packages, Components: TStrings);
begin
end;

function GetEditControlFromEditorForm(AForm: TCustomForm): TControl;
begin
end;

function GetCurrentEditControl: TControl;
begin
end;

function GetStatusBarFromEditor(EditControl: TControl): TStatusBar;
begin
end;

function GetCurrentSyncButton: TControl;
begin
end;

function GetCurrentSyncButtonVisible: Boolean;
begin
end;

function GetCodeTemplateListBox: TControl;
begin
end;

function GetCodeTemplateListBoxVisible: Boolean;
begin
end;

function IsCurrentEditorInSyncMode: Boolean;
begin
end;

function IsKeyMacroRunning: Boolean;
begin
end;

function GetCurrentCompilingProject: IOTAProject;
begin
end;

{ TCnPaletteWrapper }

procedure TCnPaletteWrapper.BeginUpdate;
begin
end;

constructor TCnPaletteWrapper.Create;
begin
end;

procedure TCnPaletteWrapper.EndUpdate;
begin
end;

function TCnPaletteWrapper.FindTab(const ATab: string): Integer;
begin
end;

function TCnPaletteWrapper.GetActiveTab: string;
begin
end;

function TCnPaletteWrapper.GetEnabled: Boolean;
begin
end;

function TCnPaletteWrapper.GetIsMultiLine: Boolean;
begin
end;

function TCnPaletteWrapper.GetPalToolCount: Integer;
begin
end;

function TCnPaletteWrapper.GetSelectedIndex: Integer;
begin
end;

function TCnPaletteWrapper.GetSelectedToolName: string;
begin
end;

function TCnPaletteWrapper.GetSelector: TSpeedButton;
begin
end;

function TCnPaletteWrapper.GetTabCount: Integer;
begin
end;

function TCnPaletteWrapper.GetTabIndex: Integer;
begin
end;

function TCnPaletteWrapper.GetTabs(Index: Integer): string;
begin
end;

function TCnPaletteWrapper.GetVisible: Boolean;
begin
end;

function TCnPaletteWrapper.SelectComponent(const AComponent,
  ATab: string): Boolean;
begin
end;

procedure TCnPaletteWrapper.SetEnabled(const Value: Boolean);
begin
end;

procedure TCnPaletteWrapper.SetSelectedIndex(const Value: Integer);
begin
end;

procedure TCnPaletteWrapper.SetTabIndex(const Value: Integer);
begin
end;

procedure TCnPaletteWrapper.SetVisible(const Value: Boolean);
begin
end;

function CnPaletteWrapper: TCnPaletteWrapper;
begin
end;
  
{ TCnMessageViewWrapper }

constructor TCnMessageViewWrapper.Create;
begin
end;

procedure TCnMessageViewWrapper.EditMessageSource;
begin
end;

function TCnMessageViewWrapper.GetCurrentMessage: string;
begin
end;

function TCnMessageViewWrapper.GetMessageCount: Integer;
begin
end;

function TCnMessageViewWrapper.GetSelectedIndex: Integer;
begin
end;

function TCnMessageViewWrapper.GetTabCaption: string;
begin
end;

function TCnMessageViewWrapper.GetTabCount: Integer;
begin
end;

function TCnMessageViewWrapper.GetTabIndex: Integer;
begin
end;

function TCnMessageViewWrapper.GetTabSetVisible: Boolean;
begin
end;

procedure TCnMessageViewWrapper.SetSelectedIndex(const Value: Integer);
begin
end;

procedure TCnMessageViewWrapper.SetTabIndex(const Value: Integer);
begin
end;

procedure TCnMessageViewWrapper.UpdateAllItems;
begin
end;

function CnMessageViewWrapper: TCnMessageViewWrapper;
begin
end;

end.

